#!/usr/bin/env python
# -*- coding: utf-8 -*-

import asyncore
import socket
import operator

TERMINATOR = "\n"

PUERTO = 5000

class Servidor(asyncore.dispatcher):
# Escucha, lee y contesta

    	def __init__(self):

        	asyncore.dispatcher.__init__(self)

		self.juego = None

		self.clientes = {} # Diccionario clave=(ip,port):valor=objeto_jugador
		self.create_socket(socket.AF_INET, socket.SOCK_DGRAM)
		self.bind(("", PUERTO))
		print "__init__ en server"

	def handle_write(self):
		jugadores = filter(operator.attrgetter('hay_cambios'), self.clientes.values())
		for jugador in jugadores:
			for cliente in self.clientes.values():
				self.sendto("%s %s %s %s %s%s" % (jugador.nombre, "Tanque", jugador.angulo, jugador.x, jugador.y, TERMINATOR), cliente.ip_puerto)
				''' if jugador.bala:
					tipo, angulo, x, y = jugador.bala[jugador.nombre]
					self.sendto("%s %s %s %s %s%s" % (jugador.nombre, tipo, angulo, x, y, TERMINATOR), cliente.ip_puerto)
					jugador.bala.clear() '''
		        	jugador.hay_cambios = False

	def handle_read(self):
		''' Se llama cuando el asynchronous loop detecta que se puede leer en el socket, entonces lee '''

		datos, ip_puerto = self.recvfrom(1000)#(4096)

		if ip_puerto not in self.clientes:
		    	self.clientes[ip_puerto] = Jugador(ip_puerto, self.clientes.values()) # Diccionario=> (ip,puerto):Jugador
			''' La clase Jugador representa a cada jugador en el juego, en el ámbito del servidor, por lo cual podemos
			considerarla un espejo de cada jugador donde se mantienen todos sus datos para ser manejados por el servidor. '''

		self.clientes[ip_puerto].Recibir_Datos(datos) # Llama al método Recibir_Datos del Jugador segun [ip_puerto]
	
	def writable(self):
		''' Llamado cada pasada por el bucle asincrónico para determinar si hay un canal.
		Debe agregarse al hay_cambiosador de eventos. De lo contrario, el método por defecto, simplemente devuelve True, lo que indica que,
		por defecto, todos los canales estarán interesados en escribir eventos. '''
		return any(map(operator.attrgetter('hay_cambios'), self.clientes.values()))


from math import sin, cos, radians

VELOCIDAD = 5
INDICE_ROTACION = 3

class Jugador(object):
	''' La clase Jugador representa a cada jugador en el juego, en el ámbito del servidor, por lo cual podemos
	considerarla un espejo de cada jugador donde se mantienen todos sus datos para ser manejados por el servidor. '''

	def __init__(self, ip_puerto, otros_jugadores):

		self.tipo = ""
		self.angulo = 0
		self.x = 0
		self.y = 0

		self.ip_puerto = ip_puerto
		self.buffer_de_entrada = ""
		self.nombre = None

		self.bala = {}

		self.hay_cambios = False

		for o in otros_jugadores:
		    o.hay_cambios = True

	def Recibir_Datos(self, datos):
		'''maneja los datos recibidos por el servidor, para cada cliente en la red.
		Este método es el espejo de found_terminator en el cliente. '''

		self.buffer_de_entrada = datos # datos es list self.buffer_de_entrada es cadena
		#print "Buffer de Entrada en Server:", self.buffer_de_entrada

		mensajes = self.buffer_de_entrada.split(TERMINATOR)

		for mensaje in mensajes:
			valores = mensaje.split()
		
			if "hello" in valores:
			# la 1º conexión
				print "Bienvenido !!!", valores[1]
				self.nombre = valores[1]
				self.hay_cambios = True

			elif "Tanque" in valores:
			# es un tanque y no es la 1º conexión

				if self.angulo != int(valores[2]) or self.x != int(valores[3]) or self.y != int(valores[4]):

					self.nombre = int(valores[0])
					self.tipo = str(valores[1])
					self.angulo = int(valores[2])
					self.x = int(valores[3])
					self.y = int(valores[4])

					self.hay_cambios = True
				self.hay_cambios = False
			'''
			elif "Bala" in valores:
				print "Llegando una bala al server", valores
				self.bala[int(valores[0])] = str(valores[1]), int(valores[2]), int(valores[3]), int(valores[4]) '''

		
			


if __name__ == "__main__":
	servidor = Servidor()
	while 1:
		asyncore.loop(timeout=0.2, count=1)
